---
title: Firefox 22 for developers
slug: Mozilla/Firefox/Releases/22
tags:
  - Firefox
  - Firefox 22
---
<div>{{FirefoxSidebar}}</div><h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The HTML5 {{HTMLElement("data")}} element has been implemented ({{bug(839371)}}).</li>
 <li>The HTML5 {{HTMLElement("time")}} element has been implemented ({{bug(629801)}}).</li>
 <li>The <code>range</code> state of the {{HTMLElement("input")}} element (<code>&lt;input type="range"&gt;</code>) has been implemented, behind the preference <code>dom.experimental_forms_range</code>, only enabled by default on Nightly and Aurora channel ({{bug(841948)}}).</li>
 <li>The support for the {{HTMLElement("template")}} element, part of the Web component specification has been implemented ({{bug(818976)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><a href="http://asmjs.org/spec/latest/">Asm.js </a>optimizations are enabled, making it possible to compile C/C++ applications to a subset of JavaScript for better performance.</li>
 <li>ES2015 <a href="/en-US/docs/JavaScript/Reference/arrow_functions">Arrow Function</a> syntax has been implemented ({{bug(846406)}}).</li>
 <li>The new <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is">Object.is</a> function has been added ({{bug(839979)}}).</li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Functions/arguments">arguments</a></code> in generator expressions is now inherited from enclosing lexical scope ({{bug(848051)}}).</li>
 <li>The ES2015 Proxy {{jsxref("Global_Objects/Proxy/handler/preventExtensions", "preventExtensions")}} trap have been implemented ({{bug(789897)}}).</li>
</ul>

<h3 id="DOM">DOM</h3>

<ul>
 <li>Support for the <code>multipart</code> property on <code>XMLHttpRequest</code> and <code>multipart/x-mixed-replace</code> responses in <code>XMLHttpRequest</code> has been removed. This was a Gecko-only feature that was never standardized. <a href="/en-US/docs/Server-sent_events" title="Server-sent_events">Server-Sent Events</a>, <a href="/en-US/docs/WebSockets" title="WebSockets">Web Sockets</a> or inspecting <code>responseText</code> from progress events can be used instead.</li>
 <li>Support for <a href="/en-US/docs/WebAPI/Using_Web_Notifications">Web Notifications</a> has been landed ({{bug(782211)}}).</li>
 <li>The {{domxref("FormData")}}  <code>append</code> method now accepts a third optional <code>filename</code> parameter ({{bug(690659)}}).</li>
 <li>{{domxref("Node.isSupported")}} has been removed ({{bug(801562)}}).</li>
 <li>{{domxref("Node.setUserData")}} and {{domxref("Node.getUserData")}} has been removed for web content and are deprecated for chrome content ({{bug(842372)}}).</li>
 <li>The {{domxref("Element.attributes")}} property has been moved there from {{domxref("Node")}} as required by the spec ({{bug("844134")}}).</li>
 <li>The Mac OS X backend for {{domxref("DeviceLightEvent", "Ambient Light Events")}} has been implemented.</li>
 <li>Elements in the HTML namespace with local names {{HTMLElement("bgsound")}}, {{HTMLElement("multicol")}}, and {{HTMLElement("image")}} no longer implement the {{domxref("HTMLSpanElement")}} interface.  {{HTMLElement("bgsound")}} and {{HTMLElement("bgsound")}} implement {{domxref("HTMLUnknownElement")}} and {{HTMLElement("image")}} implements {{domxref("HTMLElement")}}.</li>
 <li>The {{ domxref("NodeIterator.detach") }} method has been changed to do nothing ({{bug("823549")}}).</li>
 <li>The {{domxref("BlobEvent")}} interface has been implemented ({{bug("834165")}}).</li>
 <li>The properties <code>HTMLMediaElement.crossorigin</code> and <code>HTMLInputElement.inputmode</code> has been removed to match the spec in {{domxref("HTMLMediaElement.crossOrigin")}} and <code>HTMLInputElement.inputMode</code>, respectively ({{bug("847370")}} and {{bug("850346")}}).</li>
 <li>WebRTC: the Media Stream API and Peer Connection API are now supported by default.</li>
 <li>Web Components: the {{domxref("Document.register")}} method has been implemented ({{bug("783129")}}).</li>
 <li>The {{domxref("ProgressEvent.initProgressEvent()")}} constructor method has been removed. Uses the standard constructor, {{domxref("ProgressEvent.ProgressEvent", "ProgressEvent()")}} to construc and initialize {{domxref("ProgressEvent")}} ({{bug("843489")}}).</li>
 <li>Manipulated data associated with a {{event("cut")}}, {{event("copy")}}, or {{event("paste")}} event can now be accessed via the {{domxref("ClipboardEvent.clipboardData")}} property ({{bug("407983")}}).</li>
 <li>The {{domxref("HTMLTimeElement")}} interface has been implemented ({{bug("629801")}}).</li>
 <li>When a {{domxref("Worker")}} constructor is passed an invalid URL, it now throws {{domxref("DOMException")}} of type <code>SECURITY_ERR</code> ({{bug("587251")}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Support for <a href="/en-US/docs/CSS/Tutorials/Using_CSS_flexible_boxes" title="CSS/Tutorials/Using_CSS_flexible_boxes">CSS Flexbox layout</a> has been enabled by default ({{bug("841876")}}).</li>
 <li>Following a spec change, the initial value for {{cssxref("min-width")}} and {{cssxref("min-height")}} has been changed back to <code>0</code>, even on flex items ({{bug("848539")}}).</li>
 <li>Support for CSS Conditionals ({{cssxref("@supports")}} and {{domxref("CSS.supports")}}) has been enabled by default ({{bug("855455")}}).</li>
 <li>Support for {{cssxref("background-clip")}} and {{cssxref("background-origin")}} properties in the {{cssxref("background")}} shorthand has been implemented ({{bug("570896")}}).</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<ul>
 <li>The <code>properties</code> parameter has been removed from the {{ifmethod('nsITreeView','getCellProperties')}}, {{ifmethod('nsITreeView','getColumnProperties')}} and {{ifmethod('nsITreeView','getRowProperties')}} methods of {{interface('nsITreeView')}}. These methods should now return a string of space-separated property names. ({{bug('407956')}})</li>
 <li>The {{ifmethod('inIDOMUtils', 'getCSSPropertyNames')}} method has been implemented and will return all supported <a href="/en-US/docs/CSS/CSS_Reference">CSS property</a> names.</li>
 <li>See <a href="https://blog.mozilla.org/addons/2013/06/03/compatibility-for-firefox-22/">here </a>for more changes.</li>
</ul>

<h3 id="Firefox_Developer_Tools">Firefox Developer Tools</h3>

<ul>
 <li><a href="https://hacks.mozilla.org/2013/04/developer-tools-update-firefox-22/">Font inspector</a> shows which fonts on your computer are applied to the page.</li>
 <li>Visual paint feedback mode shows when and where a page is repainted.</li>
 <li>The dev tools may now be docked to the right side, not just the bottom of the browser.</li>
 <li>Some panes within the dev tools have switched from <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=875727">XUL to HTML</a>. For example, the css rule viewer is now chrome://browser/content/devtools/cssruleview.xhtml, not <span class="comment-copy"><code>cssruleview.xul</code></span>. Instead of adding an overlay directly to extend features of these panes, you may add an overlay and script to the outer xul document, to add load listeners and change these html documents.</li>
 <li>The stack trace is now shown as a breadcrumb near the top, and the script listing is now at the left panel of the debugger.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/22.0beta/releasenotes/">Firefox 22 Beta Release Notes</a></li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/22/">Site Compatibility for Firefox 22</a></li>
 <li><a href="https://blog.mozilla.org/addons/2013/06/03/compatibility-for-firefox-22/">Add-on Compatibility for Firefox 22</a></li>
</ul>

<h3 id="Versions">Versions</h3>

<div>{{Firefox_for_developers('21')}}</div>
